Index: branches/2014/dev_r4650_UKMO3_masked_damping/DOC/TexFiles/Chapters/Chap_DYN.tex
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/DOC/TexFiles/Chapters/Chap_DYN.tex	(revision 4740)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/DOC/TexFiles/Chapters/Chap_DYN.tex	(revision 4745)
@@ -795,5 +795,5 @@
 %>   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >   >
 \begin{figure}[!t]    \begin{center}
-\includegraphics[width=0.7\textwidth]{./TexFiles/Figures/Fig_time_split.pdf}
+\includegraphics[width=0.7\textwidth]{./TexFiles/Figures/Fig_DYN_dynspg_ts.pdf}
 \caption{  \label{Fig_DYN_dynspg_ts}
 Schematic of the split-explicit time stepping scheme for the external 
Index: branches/2014/dev_r4650_UKMO3_masked_damping/DOC/TexFiles/Chapters/Chap_TRA.tex
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/DOC/TexFiles/Chapters/Chap_TRA.tex	(revision 4740)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/DOC/TexFiles/Chapters/Chap_TRA.tex	(revision 4745)
@@ -1077,6 +1077,5 @@
 correctly set  ($i.e.$ that $T_o$ and $S_o$ are provided in input files and read 
 using \mdl{fldread}, see \S\ref{SBC_fldread}). 
-The restoring coefficient $\gamma$ is a three-dimensional array initialized by the 
-user in routine \rou{dtacof} also located in module \mdl{tradmp}. 
+The restoring coefficient $\gamma$ is a three-dimensional array read in during the \rou{tra\_dmp\_init} routine. The file name is specified by the namelist variable \np{cn\_resto}. The DMP\_TOOLS tool is provided to allow users to generate the netcdf file.
 
 The two main cases in which \eqref{Eq_tra_dmp} is used are \textit{(a)} 
@@ -1092,23 +1091,5 @@
 diagnostic method \citep{Sarmiento1982}. It allows us to find the velocity 
 field consistent with the model dynamics whilst having a $T$, $S$ field 
-close to a given climatological field ($T_o$, $S_o$). The time scale 
-associated with $S_o$ is generally not a constant but spatially varying 
-in order to respect other properties. For example, it is usually set to zero 
-in the mixed layer (defined either on a density or $S_o$ criterion) 
-\citep{Madec_al_JPO96} and in the equatorial region 
-\citep{Reverdin1991, Fujio1991, Marti_PhD92} since these two regions 
-have a short time scale of adjustment; while smaller $\gamma$ are used 
-in the deep ocean where the typical time scale is long \citep{Sarmiento1982}. 
-In addition the time scale is reduced (even to zero) along the western 
-boundary to allow the model to reconstruct its own western boundary 
-structure in equilibrium with its physics. 
-The choice of the shape of the Newtonian damping is controlled by two 
-namelist parameters \np{nn\_hdmp} and \np{nn\_zdmp}. The former allows us to specify: the 
-width of the equatorial band in which no damping is applied; a decrease 
-in the vicinity of the coast; and a damping everywhere in the Red and Med Seas.
-The latter sets whether damping should act in the mixed layer or not. 
-The time scale associated with the damping depends on the depth as
-a hyperbolic tangent, with \np{rn\_surf} as surface value, \np{rn\_bot} as 
-bottom value and a transition depth of \np{rn\_dep}.  
+close to a given climatological field ($T_o$, $S_o$). 
 
 The robust diagnostic method is very efficient in preventing temperature 
@@ -1118,9 +1099,19 @@
 by stabilising the water column too much.
 
-An example of the computation of $\gamma$ for a robust diagnostic experiment 
-with the ORCA2 model is provided in the \mdl{tradmp} module 
-(subroutines \rou{dtacof} and \rou{cofdis} which compute the coefficient 
-and the distance to the bathymetry, respectively). These routines are 
-provided as examples and can be customised by the user. 
+The namelist parameter \np{nn\_zdmp} sets whether the damping should be applied in the whole water column or only below the mixed layer (defined either on a density or $S_o$ criterion). It is common to set the damping to zero in the mixed layer as the adjustment time scale is short here \citep{Madec_al_JPO96}.
+
+\subsection[DMP\_TOOLS]{Generating resto.nc using DMP\_TOOLS}
+
+DMP\_TOOLS can be used to generate a netcdf file containing the restoration coefficient $\gamma$. Note that in order to maintain bit comparison with previous NEMO versions DMP\_TOOLS must be compiled and run on the same machine as the NEMO model. A mesh\_mask.nc file for the model configuration is required as an input. This can be generated by carrying out a short model run with the namelist parameter \np{nn\_msh} set to 1. The namelist parameter \np{ln\_tradmp} will also need to be set to .false. for this to work. The \nl{nam\_dmp\_create} namelist in the DMP\_TOOLS directory is used to specify options for the restoration coefficient.
+
+%--------------------------------------------nam_dmp_create-------------------------------------------------
+\namdisplay{nam_dmp_create}
+%-------------------------------------------------------------------------------------------------------
+
+\np{cp\_cfg}, \np{cp\_cpz}, \np{jp\_cfg} and \np{jperio} specify the model configuration being used and should be the same as specified in \nl{namcfg}. The variable \nl{lzoom} is used to specify that the damping is being used as in case \textit{a} above to provide boundary conditions to a zoom configuration. In the case of the arctic or antarctic zoom configurations this includes some specific treatment. Otherwise damping is applied to the 6 grid points along the ocean boundaries. The open boundaries are specified by the variables \np{lzoom\_n}, \np{lzoom\_e}, \np{lzoom\_s}, \np{lzoom\_w} in the \nl{nam\_zoom\_dmp} name list.
+
+The remaining switch namelist variables determine the spatial variation of the restoration coefficient in non-zoom configurations. \np{ln\_full\_field} specifies that newtonian damping should be applied to the whole model domain. \np{ln\_med\_red\_seas} specifies grid specific restoration coefficients in the Mediterranean Sea for the ORCA4, ORCA2 and ORCA05 configurations. If \np{ln\_old\_31\_lev\_code} is set then the depth variation of the coeffients will be specified as a function of the model number. This option is included to allow backwards compatability of the ORCA2 reference configurations with previous model versions. \np{ln\_coast} specifies that the restoration coefficient should be reduced near to coastlines. This option only has an effect if \np{ln\_full\_field} is true. \np{ln\_zero\_top\_layer} specifies that the restoration coefficient should be zero in the surface layer. Finally \np{ln\_custom} specifies that the custom module will be called. This module is contained in the file custom.F90 and can be edited by users. For example damping could be applied in a specific region.
+
+The restoration coefficient can be set to zero in equatorial regions by specifying a positive value of \np{nn\_hdmp}. Equatorward of this latitude the restoration coefficient will be zero with a smooth transition to the full values of a 10$^{\circ}$ latitud band. This is often used because of the short adjustment time scale in the equatorial region \citep{Reverdin1991, Fujio1991, Marti_PhD92}. The time scale associated with the damping depends on the depth as a hyperbolic tangent, with \np{rn\_surf} as surface value, \np{rn\_bot} as bottom value and a transition depth of \np{rn\_dep}.  
 
 % ================================================================
Index: branches/2014/dev_r4650_UKMO3_masked_damping/DOC/TexFiles/Namelist/namtra_dmp
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/DOC/TexFiles/Namelist/namtra_dmp	(revision 4740)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/DOC/TexFiles/Namelist/namtra_dmp	(revision 4745)
@@ -2,14 +2,9 @@
 &namtra_dmp    !   tracer: T & S newtonian damping
 !-----------------------------------------------------------------------
-   ln_tradmp   =  .true.   !  add a damping termn (T) or not (F)
-   nn_hdmp     =   -1      !  horizontal shape =-1, damping in Med and Red Seas only
-                           !                   =XX, damping poleward of XX degrees (XX>0)
-                           !                      + F(distance-to-coast) + Red and Med Seas
-   nn_zdmp     =    0      !  vertical   shape =0    damping throughout the water column
-                           !                   =1 no damping in the mixing layer (kz  criteria)
-                           !                   =2 no damping in the mixed  layer (rho crieria)
-   rn_surf     =   50.     !  surface time scale of damping   [days]
-   rn_bot      =  360.     !  bottom  time scale of damping   [days]
-   rn_dep      =  800.     !  depth of transition between rn_surf and rn_bot [meters]
-   nn_file     =    0      !  create a damping.coeff NetCDF file (=1) or not (=0)
+   ln_tradmp   =  .true.     !  add a damping termn (T) or not (F)
+   nn_zdmp     =    0        !  vertical   shape =0    damping throughout the water column
+                             !                   =1 no damping in the mixing layer (kz  criteria)
+                             !                   =2 no damping in the mixed  layer (rho crieria)
+   cn_resto    = 'resto.nc'  ! Name of file containing restoration coefficient field (use dmp_tools to create this)
+
 /
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/DMP_TOOLS/namelist
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/DMP_TOOLS/namelist	(revision 4740)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/DMP_TOOLS/namelist	(revision 4745)
@@ -10,8 +10,8 @@
     ln_zero_top_layer = .true. ! No damping in top layer
     ln_custom = .false.        ! Call "custom" module to apply user modifications to the damping coefficient field
+    nn_hdmp = 10               ! Damp poleward of this latitude (smooth transition up to maximum damping)
     pn_surf = 0.25             ! Surface Relaxation timescale (days) 
     pn_bot = 0.25              ! Bottom relaxation timescale (days)
     pn_dep = 1000              ! Transition depth from upper to deep ocean
-    nn_hdmp = 10               ! Damp poleward of this latitude (smooth transition up to maximum damping)
     jperio = 2                 ! Lateral boundary condition (as specified in namelist_cfg for model run).
 /
Index: branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/DMP_TOOLS/src/make_dmp_file.F90
===================================================================
--- branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/DMP_TOOLS/src/make_dmp_file.F90	(revision 4740)
+++ branches/2014/dev_r4650_UKMO3_masked_damping/NEMOGCM/TOOLS/DMP_TOOLS/src/make_dmp_file.F90	(revision 4745)
@@ -8,7 +8,7 @@
   !
   !  Method:  1) Read in tmask from mesh_mask file to use as a template
-  !           2) Calculate restoration coefficients (user should modify to their
-  !           own specifications e.g. to mask certain regions only).
-  !           Avoid 3D arrays!
+  !           2) Calculate restoration coefficients according to options
+  !           specified in the namelist. The user may modify custom.F90 to
+  !           specify specific damping options e.g. to mask certain regions only).
   !           3) Write the array to output file
   !